import java.util.Random;

/**
 * This class investigates the behavior of the search methods in Searches.
 */
public class SearchTester
{
    /**
     * This method creates and returns an array of ints of the specified size.  
     * It ensures that the values in the array are in increasing order, yet 
     * random, by remembering the last value added to the array and adding a 
     * random int to *that* value to produce the next each time.
     * 
     * @param size  The length of the array to be created
     * @return An ordered array of integers of the specified size
     */
    public int[] buildOrderedArray(int size) {
        int[] nums = new int[size];     // Create the array we're going to fill
        Random rng = new Random();
        int next = 0;                   // Stores prevous value added to array
        for(int i=0; i<size; i=i+1) {       
            next = next + rng.nextInt(10);  // Add random to previous value to get next
            nums[i] = next;
        }
        return nums;
    }

    /**
     * This method creates an array of length size, performs multiple linear 
     * searches on it, and reports the average number of comparisons required 
     * per search. (For each search, it should select an item from the array at 
     * random, then search for it.)
     * 
     * @param size  The length of the array to be searched
     * @param numSearches  The number of searches to be performed
     */
    public void averageLinearSearchCost(int size, int numSearches) {
        // Create an array of specified size (using helper above)
        // Create a Searches object, so we can call search methods
        // Do specified number of searches (for keys at random positions)
        // Calculate the average number of comparisons & return it
    }    

    /**
     * This method creates an array of length size, performs multiple binary 
     * searches on it, and reports the average number of comparisons required 
     * per search.
     * 
     * @param size  The length of the array to be searched
     * @param numSearches  The number of searches to be performed
     */
    public void averageBinarySearchCost(int size, int numSearches) {
        // Just like method above, but using binarySearch
    }

    
    public void runTests() {
        
        // Fill this in too
    }
}
